/* ***********************************************************
 * This file was automatically generated on 2019-12-19.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;

/**
 * Measures CO2 concentration in ppm
 */
public class BrickletCO2 extends Device {
	public final static int DEVICE_IDENTIFIER = 262;
	public final static String DEVICE_DISPLAY_NAME = "CO2 Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletco2", DEVICE_IDENTIFIER, BrickletCO2.class, BrickletCO2Actions.class, "2.0.0");

	public final static byte FUNCTION_GET_CO2_CONCENTRATION = (byte)1;
	public final static byte FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_CO2_CONCENTRATION = 8;
	private final static int CALLBACK_CO2_CONCENTRATION_REACHED = 9;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';

	private List<CO2ConcentrationListener> listenerCO2Concentration = new CopyOnWriteArrayList<CO2ConcentrationListener>();
	private List<CO2ConcentrationReachedListener> listenerCO2ConcentrationReached = new CopyOnWriteArrayList<CO2ConcentrationReachedListener>();

	public class CO2ConcentrationCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletCO2#setCO2ConcentrationCallbackPeriod(long)}. The parameter is the CO2
	 * concentration of the sensor.
	 * 
	 * The {@link BrickletCO2.CO2ConcentrationListener} listener is only triggered if the CO2 concentration
	 * has changed since the last triggering.
	 */
	public interface CO2ConcentrationListener extends DeviceListener {
		public void co2Concentration(int co2Concentration);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletCO2#setCO2ConcentrationCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the CO2 concentration.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletCO2#setDebouncePeriod(long)}.
	 */
	public interface CO2ConcentrationReachedListener extends DeviceListener {
		public void co2ConcentrationReached(int co2Concentration);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletCO2(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CO2_CONCENTRATION)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_CO2_CONCENTRATION] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int co2Concentration = IPConnection.unsignedShort(bb.getShort());

				for (CO2ConcentrationListener listener: listenerCO2Concentration) {
					listener.co2Concentration(co2Concentration);
				}
			}
		};

		callbacks[CALLBACK_CO2_CONCENTRATION_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int co2Concentration = IPConnection.unsignedShort(bb.getShort());

				for (CO2ConcentrationReachedListener listener: listenerCO2ConcentrationReached) {
					listener.co2ConcentrationReached(co2Concentration);
				}
			}
		};
	}

	/**
	 * Returns the measured CO2 concentration.
	 * 
	 * If you want to get the CO2 concentration periodically, it is recommended to use
	 * the {@link BrickletCO2.CO2ConcentrationListener} listener and set the period with
	 * {@link BrickletCO2#setCO2ConcentrationCallbackPeriod(long)}.
	 */
	public int getCO2Concentration() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CO2_CONCENTRATION, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int co2Concentration = IPConnection.unsignedShort(bb.getShort());

		return co2Concentration;
	}

	/**
	 * Sets the period with which the {@link BrickletCO2.CO2ConcentrationListener} listener is
	 * triggered periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletCO2.CO2ConcentrationListener} listener is only triggered if the CO2 concentration
	 * has changed since the last triggering.
	 */
	public void setCO2ConcentrationCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletCO2#setCO2ConcentrationCallbackPeriod(long)}.
	 */
	public long getCO2ConcentrationCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletCO2.CO2ConcentrationReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the CO2 concentration is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the CO2 concentration is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the CO2 concentration is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the CO2 concentration is greater than the min value (max is ignored)"
	 * \endverbatim
	 */
	public void setCO2ConcentrationCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)13, FUNCTION_SET_CO2_CONCENTRATION_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putShort((short)min);
		bb.putShort((short)max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletCO2#setCO2ConcentrationCallbackThreshold(char, int, int)}.
	 */
	public CO2ConcentrationCallbackThreshold getCO2ConcentrationCallbackThreshold() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_CO2_CONCENTRATION_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CO2ConcentrationCallbackThreshold obj = new CO2ConcentrationCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = IPConnection.unsignedShort(bb.getShort());
		obj.max = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listeners
	 * 
	 * * {@link BrickletCO2.CO2ConcentrationReachedListener},
	 * 
	 * are triggered, if the thresholds
	 * 
	 * * {@link BrickletCO2#setCO2ConcentrationCallbackThreshold(char, int, int)},
	 * 
	 * keep being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletCO2#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a CO2Concentration listener.
	 */
	public void addCO2ConcentrationListener(CO2ConcentrationListener listener) {
		listenerCO2Concentration.add(listener);
	}

	/**
	 * Removes a CO2Concentration listener.
	 */
	public void removeCO2ConcentrationListener(CO2ConcentrationListener listener) {
		listenerCO2Concentration.remove(listener);
	}

	/**
	 * Adds a CO2ConcentrationReached listener.
	 */
	public void addCO2ConcentrationReachedListener(CO2ConcentrationReachedListener listener) {
		listenerCO2ConcentrationReached.add(listener);
	}

	/**
	 * Removes a CO2ConcentrationReached listener.
	 */
	public void removeCO2ConcentrationReachedListener(CO2ConcentrationReachedListener listener) {
		listenerCO2ConcentrationReached.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletCO2.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletCO2.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        this.addCO2ConcentrationListener((co2Concentration) -> {if(true) {updateStateFn.accept("BrickletCO2CO2Concentration", transformBrickletCO2CO2ConcentrationCallback0(co2Concentration, cfg));}});
        
		{
		BrickletBrickletCO2CO2ConcentrationConfig channelCfg = getChannelConfigFn.apply("BrickletCO2CO2Concentration").as(BrickletBrickletCO2CO2ConcentrationConfig.class);
		this.setCO2ConcentrationCallbackPeriod(channelCfg.updateInterval);
		this.setCO2ConcentrationCallbackThreshold('x', 0, 0);
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        this.listenerCO2Concentration.clear();
        this.setCO2ConcentrationCallbackPeriod(0);
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletCO2CO2Concentration");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletCO2CO2Concentration":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletCO2CO2Concentration"), "CO2 Concentration", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletCO2CO2Concentration")).withDescription("The measured CO2 concentration.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(10000)).withPattern("%d %unit%").withReadOnly(true).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge CO2 Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Measures CO2 concentration in ppm").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletCO2CO2Concentration", new ChannelTypeUID("tinkerforge", "BrickletCO2CO2Concentration")).withLabel("CO2 Concentration").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletco2":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletCO2CO2Concentration":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        switch(channel) {
            case "BrickletCO2CO2Concentration": {
                   BrickletBrickletCO2CO2ConcentrationConfig channelCfg = channelConfig.as(BrickletBrickletCO2CO2ConcentrationConfig.class);
                   {
            int value = this.getCO2Concentration();
            if(true)
                updateStateFn.accept(channel, transformBrickletCO2CO2ConcentrationGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletCO2Config cfg = (BrickletCO2Config) config.as(BrickletCO2Config.class);
        switch(channel) {
            
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletCO2CO2ConcentrationCallback0(int co2Concentration, BrickletCO2Config cfg) {
        return new QuantityType<>(co2Concentration, SmartHomeUnits.PARTS_PER_MILLION);
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletCO2CO2ConcentrationGetter0(int value, BrickletCO2Config cfg) {
        return new QuantityType<>(value, SmartHomeUnits.PARTS_PER_MILLION);
    }
}
