/* ***********************************************************
 * This file was automatically generated on 2019-12-19.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.OnOffType;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 4 galvanically isolated solid state relays
 */
public class BrickletIndustrialQuadRelay extends Device {
	public final static int DEVICE_IDENTIFIER = 225;
	public final static String DEVICE_DISPLAY_NAME = "Industrial Quad Relay Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletindustrialquadrelay", DEVICE_IDENTIFIER, BrickletIndustrialQuadRelay.class, BrickletIndustrialQuadRelayActions.class, "2.0.0");

	public final static byte FUNCTION_SET_VALUE = (byte)1;
	public final static byte FUNCTION_GET_VALUE = (byte)2;
	public final static byte FUNCTION_SET_MONOFLOP = (byte)3;
	public final static byte FUNCTION_GET_MONOFLOP = (byte)4;
	public final static byte FUNCTION_SET_GROUP = (byte)5;
	public final static byte FUNCTION_GET_GROUP = (byte)6;
	public final static byte FUNCTION_GET_AVAILABLE_FOR_GROUP = (byte)7;
	public final static byte FUNCTION_SET_SELECTED_VALUES = (byte)9;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_MONOFLOP_DONE = 8;


	private List<MonoflopDoneListener> listenerMonoflopDone = new CopyOnWriteArrayList<MonoflopDoneListener>();

	public class Monoflop {
		public int value;
		public long time;
		public long timeRemaining;

		public String toString() {
			return "[" + "value = " + value + ", " + "time = " + time + ", " + "timeRemaining = " + timeRemaining + "]";
		}
	}

	/**
	 * This listener is triggered whenever a monoflop timer reaches 0. The
	 * parameters contain the involved pins and the current value of the pins
	 * (the value after the monoflop).
	 */
	public interface MonoflopDoneListener extends DeviceListener {
		public void monoflopDone(int selectionMask, int valueMask);
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletIndustrialQuadRelay(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_MONOFLOP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_GROUP)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_AVAILABLE_FOR_GROUP)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_SELECTED_VALUES)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_MONOFLOP_DONE] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int selectionMask = IPConnection.unsignedShort(bb.getShort());
				int valueMask = IPConnection.unsignedShort(bb.getShort());

				for (MonoflopDoneListener listener: listenerMonoflopDone) {
					listener.monoflopDone(selectionMask, valueMask);
				}
			}
		};
	}

	/**
	 * Sets the output value with a bitmask (16bit). A 1 in the bitmask means relay
	 * closed and a 0 means relay open.
	 * 
	 * For example: The value 3 or 0b0011 will close the relay of pins 0-1 and open
	 * the other pins.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialQuadRelay#setGroup(char[])}), the pins correspond to the
	 * markings on the Industrial Quad Relay Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 * 
	 * All running monoflop timers will be aborted if this function is called.
	 */
	public void setValue(int valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)10, FUNCTION_SET_VALUE, this);

		bb.putShort((short)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the bitmask as set by {@link BrickletIndustrialQuadRelay#setValue(int)}.
	 */
	public int getValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int valueMask = IPConnection.unsignedShort(bb.getShort());

		return valueMask;
	}

	/**
	 * Configures a monoflop of the pins specified by the first parameter
	 * bitmask.
	 * 
	 * The second parameter is a bitmask with the desired value of the specified
	 * pins. A 1 in the bitmask means relay closed and a 0 means relay open.
	 * 
	 * The third parameter indicates the time that the pins should hold
	 * the value.
	 * 
	 * If this function is called with the parameters (9, 1, 1500) or
	 * (0b1001, 0b0001, 1500): Pin 0 will close and pin 3 will open. In 1.5s pin 0
	 * will open and pin 3 will close again.
	 * 
	 * A monoflop can be used as a fail-safe mechanism. For example: Lets assume you
	 * have a RS485 bus and a Quad Relay Bricklet connected to one of the slave
	 * stacks. You can now call this function every second, with a time parameter
	 * of two seconds and pin 0 closed. Pin 0 will be closed all the time. If now
	 * the RS485 connection is lost, then pin 0 will be opened in at most two seconds.
	 */
	public void setMonoflop(int selectionMask, int valueMask, long time) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)16, FUNCTION_SET_MONOFLOP, this);

		bb.putShort((short)selectionMask);
		bb.putShort((short)valueMask);
		bb.putInt((int)time);

		sendRequest(bb.array());
	}

	/**
	 * Returns (for the given pin) the current value and the time as set by
	 * {@link BrickletIndustrialQuadRelay#setMonoflop(int, int, long)} as well as the remaining time until the value flips.
	 * 
	 * If the timer is not running currently, the remaining time will be returned
	 * as 0.
	 */
	public Monoflop getMonoflop(short pin) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_MONOFLOP, this);

		bb.put((byte)pin);

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Monoflop obj = new Monoflop();
		obj.value = IPConnection.unsignedShort(bb.getShort());
		obj.time = IPConnection.unsignedInt(bb.getInt());
		obj.timeRemaining = IPConnection.unsignedInt(bb.getInt());

		return obj;
	}

	/**
	 * Sets a group of Quad Relay Bricklets that should work together. You can
	 * find Bricklets that can be grouped together with {@link BrickletIndustrialQuadRelay#getAvailableForGroup()}.
	 * 
	 * The group consists of 4 elements. Element 1 in the group will get pins 0-3,
	 * element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
	 * 
	 * Each element can either be one of the ports ('a' to 'd') or 'n' if it should
	 * not be used.
	 * 
	 * For example: If you have two Quad Relay Bricklets connected to port A and
	 * port B respectively, you could call with ``['a', 'b', 'n', 'n']``.
	 * 
	 * Now the pins on the Quad Relay on port A are assigned to 0-3 and the
	 * pins on the Quad Relay on port B are assigned to 4-7. It is now possible
	 * to call {@link BrickletIndustrialQuadRelay#setValue(int)} and control two Bricklets at the same time.
	 */
	public void setGroup(char[] group) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_GROUP, this);

		for (int i = 0; i < 4; i++) {
			bb.put((byte)group[i]);
		}

		sendRequest(bb.array());
	}

	/**
	 * Returns the group as set by {@link BrickletIndustrialQuadRelay#setGroup(char[])}
	 */
	public char[] getGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		char[] group = new char[4];
		for (int i = 0; i < 4; i++) {
			group[i] = (char)(bb.get());
		}

		return group;
	}

	/**
	 * Returns a bitmask of ports that are available for grouping. For example the
	 * value 5 or 0b0101 means: Port A and port C are connected to Bricklets that
	 * can be grouped together.
	 */
	public short getAvailableForGroup() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_AVAILABLE_FOR_GROUP, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		short available = IPConnection.unsignedByte(bb.get());

		return available;
	}

	/**
	 * Sets the output value with a bitmask, according to the selection mask.
	 * The bitmask is 16 bit long, *true* refers to a closed relay and
	 * *false* refers to an open relay.
	 * 
	 * For example: The values (3, 1) or (0b0011, 0b0001) will close the relay of
	 * pin 0, open the relay of pin 1 and leave the others untouched.
	 * 
	 * If no groups are used (see {@link BrickletIndustrialQuadRelay#setGroup(char[])}), the pins correspond to the
	 * markings on the Industrial Quad Relay Bricklet.
	 * 
	 * If groups are used, the pins correspond to the element in the group.
	 * Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
	 * pins 8-11 and element 4 pins 12-15.
	 * 
	 * Running monoflop timers for the selected relays will be aborted if this function
	 * is called.
	 */
	public void setSelectedValues(int selectionMask, int valueMask) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_SELECTED_VALUES, this);

		bb.putShort((short)selectionMask);
		bb.putShort((short)valueMask);

		sendRequest(bb.array());
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a MonoflopDone listener.
	 */
	public void addMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.add(listener);
	}

	/**
	 * Removes a MonoflopDone listener.
	 */
	public void removeMonoflopDoneListener(MonoflopDoneListener listener) {
		listenerMonoflopDone.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelay.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletIndustrialQuadRelay.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 0)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay0", transformBrickletIndustrialQuadRelayRelay0Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 1)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay1", transformBrickletIndustrialQuadRelayRelay1Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 2)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay2", transformBrickletIndustrialQuadRelayRelay2Callback0(selectionMask, valueMask, cfg));}});
		this.addMonoflopDoneListener((selectionMask, valueMask) -> {if((selectionMask & (1 << 3)) == 1) {updateStateFn.accept("BrickletIndustrialQuadRelayRelay3", transformBrickletIndustrialQuadRelayRelay3Callback0(selectionMask, valueMask, cfg));}});
        
		{
		BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayRelay0").as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayRelay1").as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayRelay2").as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayRelay3").as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayMonofloprelay0").as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayMonofloprelay1").as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayMonofloprelay2").as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
		{
		BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = getChannelConfigFn.apply("BrickletIndustrialQuadRelayMonofloprelay3").as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
		this.listenerMonoflopDone.clear();
        
		
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletIndustrialQuadRelayRelay0");
		result.add("BrickletIndustrialQuadRelayRelay1");
		result.add("BrickletIndustrialQuadRelayRelay2");
		result.add("BrickletIndustrialQuadRelayRelay3");
		result.add("BrickletIndustrialQuadRelayMonofloprelay0");
		result.add("BrickletIndustrialQuadRelayMonofloprelay1");
		result.add("BrickletIndustrialQuadRelayMonofloprelay2");
		result.add("BrickletIndustrialQuadRelayMonofloprelay3");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletIndustrialQuadRelayRelay":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay"), "NOT USED", "Switch").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialQuadRelayRelay")).withDescription("NOT USED").build();
            case "BrickletIndustrialQuadRelayMonoflop":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop"), "NOT USED", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletIndustrialQuadRelayMonoflop")).withDescription("Triggers a monoflop as configured")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("TRIGGER", "Trigger")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Industrial Quad Relay Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("4 galvanically isolated solid state relays").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 0").withDescription("Switches Relay 0. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 1").withDescription("Switches Relay 1. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 2").withDescription("Switches Relay 2. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayRelay3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayRelay")).withLabel("Relay 3").withDescription("Switches Relay 3. A running monoflop timer for this relay will be aborted if the relay is toggled by this channel.").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonofloprelay0", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 0").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonofloprelay1", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 1").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonofloprelay2", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 2").build(), new ChannelDefinitionBuilder("BrickletIndustrialQuadRelayMonofloprelay3", new ChannelTypeUID("tinkerforge", "BrickletIndustrialQuadRelayMonoflop")).withLabel("Monoflop Relay 3").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletindustrialquadrelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletIndustrialQuadRelayRelay":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            case "channel-type:tinkerforge:BrickletIndustrialQuadRelayMonoflop":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList(ConfigDescriptionParameterBuilder.create("monoflopDuration", Type.INTEGER).withDefault("1000").withDescription("The time (in ms) that the relay should hold the configured value.").withLabel("Monoflop Duration").withUnit("ms").withAdvanced(true).withMinimum(BigDecimal.valueOf(0)).withMaximum(BigDecimal.valueOf(4294967295L)).build(), ConfigDescriptionParameterBuilder.create("monoflopValue", Type.BOOLEAN).withDefault("true").withDescription("The desired value of the specified channel. Activated means relay closed and Deactivated means relay open.").withLabel("Monoflop Value").withAdvanced(true).build())).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        switch(channel) {
            case "BrickletIndustrialQuadRelayRelay0": {
                   BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayRelay1": {
                   BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayRelay2": {
                   BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayRelay3": {
                   BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                   {
            int value = this.getValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayRelay3Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonofloprelay0": {
                   BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop((short) 0);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonofloprelay0Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonofloprelay1": {
                   BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop((short) 1);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonofloprelay1Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonofloprelay2": {
                   BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop((short) 2);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonofloprelay2Getter0(value, cfg));
        }
                   return;
               }
            case "BrickletIndustrialQuadRelayMonofloprelay3": {
                   BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                   {
            Monoflop value = this.getMonoflop((short) 3);
            if(true)
                updateStateFn.accept(channel, transformBrickletIndustrialQuadRelayMonofloprelay3Getter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletIndustrialQuadRelayConfig cfg = (BrickletIndustrialQuadRelayConfig) config.as(BrickletIndustrialQuadRelayConfig.class);
        switch(channel) {
            case "BrickletIndustrialQuadRelayRelay0":
                if (command instanceof OnOffType) {
                    BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 0)) : (getValue() & ~(1 << 0)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayRelay1":
                if (command instanceof OnOffType) {
                    BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 1)) : (getValue() & ~(1 << 1)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayRelay2":
                if (command instanceof OnOffType) {
                    BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 2)) : (getValue() & ~(1 << 2)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayRelay3":
                if (command instanceof OnOffType) {
                    BrickletBrickletIndustrialQuadRelayRelayConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayRelayConfig.class);
                    OnOffType cmd = (OnOffType) command;
                    this.setValue(cmd == OnOffType.ON ? (getValue() | (1 << 3)) : (getValue() & ~(1 << 3)));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of OnOffType.", command.getClass().getName(), channel);
                }
                
                break;
            case "BrickletIndustrialQuadRelayMonofloprelay0":
                if (command instanceof StringType) {
                    BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 0, channelCfg.monoflopValue.booleanValue() ? (1 << 0) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay0", 0));
                break;
            case "BrickletIndustrialQuadRelayMonofloprelay1":
                if (command instanceof StringType) {
                    BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 1, channelCfg.monoflopValue.booleanValue() ? (1 << 1) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay1", 0));
                break;
            case "BrickletIndustrialQuadRelayMonofloprelay2":
                if (command instanceof StringType) {
                    BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 2, channelCfg.monoflopValue.booleanValue() ? (1 << 2) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay2", 0));
                break;
            case "BrickletIndustrialQuadRelayMonofloprelay3":
                if (command instanceof StringType) {
                    BrickletBrickletIndustrialQuadRelayMonoflopConfig channelCfg = channelConfig.as(BrickletBrickletIndustrialQuadRelayMonoflopConfig.class);
                    StringType cmd = (StringType) command;
                    this.setMonoflop(1 << 3, channelCfg.monoflopValue.booleanValue() ? (1 << 3) : 0, channelCfg.monoflopDuration);
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of StringType.", command.getClass().getName(), channel);
                }
                result.add(new SetterRefresh("BrickletIndustrialQuadRelayRelay3", 0));
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay0Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 0)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay1Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 1)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay2Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 2)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay3Callback0(int selectionMask, int valueMask, BrickletIndustrialQuadRelayConfig cfg) {
        return (valueMask & (1 << 3)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay0Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 0)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay1Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 1)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay2Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 2)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayRelay3Getter0(int value, BrickletIndustrialQuadRelayConfig cfg) {
        return (value & (1 << 3)) == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonofloprelay0Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonofloprelay1Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonofloprelay2Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
	    private org.eclipse.smarthome.core.types.State transformBrickletIndustrialQuadRelayMonofloprelay3Getter0(Monoflop value, BrickletIndustrialQuadRelayConfig cfg) {
        return value.value == 1 ? OnOffType.ON : OnOffType.OFF;
    }
}
