/* ***********************************************************
 * This file was automatically generated on 2019-12-19.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.library.types.HSBType;

/**
 * Controls one RGB LED
 */
public class BrickletRGBLED extends Device {
	public final static int DEVICE_IDENTIFIER = 271;
	public final static String DEVICE_DISPLAY_NAME = "RGB LED Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "brickletrgbled", DEVICE_IDENTIFIER, BrickletRGBLED.class, BrickletRGBLEDActions.class, "2.0.1");

	public final static byte FUNCTION_SET_RGB_VALUE = (byte)1;
	public final static byte FUNCTION_GET_RGB_VALUE = (byte)2;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;



	public class RGBValue {
		public short r;
		public short g;
		public short b;

		public String toString() {
			return "[" + "r = " + r + ", " + "g = " + g + ", " + "b = " + b + "]";
		}
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletRGBLED(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_RGB_VALUE)] = RESPONSE_EXPECTED_FLAG_FALSE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_RGB_VALUE)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
	}

	/**
	 * Sets the *r*, *g* and *b* values for the LED.
	 */
	public void setRGBValue(short r, short g, short b) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)11, FUNCTION_SET_RGB_VALUE, this);

		bb.put((byte)r);
		bb.put((byte)g);
		bb.put((byte)b);

		sendRequest(bb.array());
	}

	/**
	 * Returns the *r*, *g* and *b* values of the LED as set by {@link BrickletRGBLED#setRGBValue(short, short, short)}.
	 */
	public RGBValue getRGBValue() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_RGB_VALUE, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		RGBValue obj = new RGBValue();
		obj.r = IPConnection.unsignedByte(bb.get());
		obj.g = IPConnection.unsignedByte(bb.get());
		obj.b = IPConnection.unsignedByte(bb.get());

		return obj;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
	 * The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
	 * connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
	 * position 'z'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletRGBLED.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRGBLED.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRGBLEDConfig cfg = (BrickletRGBLEDConfig) config.as(BrickletRGBLEDConfig.class);
        
        
		{
		BrickletBrickletRGBLEDColorConfig channelCfg = getChannelConfigFn.apply("BrickletRGBLEDColor").as(BrickletBrickletRGBLEDColorConfig.class);
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletRGBLEDConfig cfg = (BrickletRGBLEDConfig) config.as(BrickletRGBLEDConfig.class);
        
        
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRGBLEDConfig cfg = (BrickletRGBLEDConfig) config.as(BrickletRGBLEDConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("BrickletRGBLEDColor");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "BrickletRGBLEDColor":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "BrickletRGBLEDColor"), "LED Color", "Color").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:BrickletRGBLEDColor")).withDescription("The color of the LED.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withReadOnly(false).build().toStateDescription()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
             Map<String, String> thingTypeProperties = ThingTypeBuilder.instance(thingTypeUID, "unused").build().getProperties();
             Map<String, String> props = new HashMap<String, String>(thingTypeProperties);
             props.putIfAbsent(TinkerforgeBindingConstants.PROPERTY_MINIMUM_FIRMWARE_VERSION, DEVICE_INFO.minimum_fw_version);
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge RGB LED Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("Controls one RGB LED").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("BrickletRGBLEDColor", new ChannelTypeUID("tinkerforge", "BrickletRGBLEDColor")).withLabel("LED Color").build())).withProperties(props).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:brickletrgbled":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals"))).build();
            case "channel-type:tinkerforge:BrickletRGBLEDColor":
                return ConfigDescriptionBuilder.create(uri).withParameters(Arrays.asList()).withParameterGroups(Arrays.asList()).build();
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRGBLEDConfig cfg = (BrickletRGBLEDConfig) config.as(BrickletRGBLEDConfig.class);
        switch(channel) {
            case "BrickletRGBLEDColor": {
                   BrickletBrickletRGBLEDColorConfig channelCfg = channelConfig.as(BrickletBrickletRGBLEDColorConfig.class);
                   {
            RGBValue value = this.getRGBValue();
            if(true)
                updateStateFn.accept(channel, transformBrickletRGBLEDColorGetter0(value, cfg));
        }
                   return;
               }
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = Collections.emptyList();
        BrickletRGBLEDConfig cfg = (BrickletRGBLEDConfig) config.as(BrickletRGBLEDConfig.class);
        switch(channel) {
            case "BrickletRGBLEDColor":
                if (command instanceof HSBType) {
                    BrickletBrickletRGBLEDColorConfig channelCfg = channelConfig.as(BrickletBrickletRGBLEDColorConfig.class);
                    HSBType cmd = (HSBType) command;
                    this.setRGBValue((short)(cmd.getRed().doubleValue() * 255.0 / 100.0), (short)(cmd.getGreen().doubleValue() * 255.0 / 100.0), (short)(cmd.getBlue().doubleValue() * 255.0 / 100.0));
                }
        
                else {
                    logger.warn("Command type {} not supported for channel {}. Please use one of HSBType.", command.getClass().getName(), channel);
                }
                
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformBrickletRGBLEDColorGetter0(RGBValue value, BrickletRGBLEDConfig cfg) {
        return HSBType.fromRGB(value.r, value.g, value.b);
    }
}
